//
//  CObjetoGrafico.m
//  PintadorIPhone
//
//  Created by rcanales on 13/02/10.
//  Copyright 2010 Autentia. All rights reserved.
//

#import "CObjetoGrafico.h"

@implementation CObjetoGrafico

@synthesize x;			// getters y setters automaticos
@synthesize y;			// getters y setters automaticos
@synthesize ancho;		// getters y setters automaticos
@synthesize alto;		// getters y setters automaticos

// inicializamo la clase base
-(id) initConValores:(NSInteger) px y:(NSInteger)py ancho:(NSInteger)pancho alto:(NSInteger)palto
{
	self = [super init];	// leer convenciones
	
	self.x = px;
	self.y = py;
	self.ancho = pancho;
	self.alto = palto;
	
	return self;			// simpre retornar self
}


-(void) traza		// mostramos el contenido
{
	NSLog(@"valor X: %d",x);
	NSLog(@"valor Y: %d",y);
	NSLog(@"valor Ancho: %d",ancho);
	NSLog(@"valor Alto: %d",alto);	
	NSLog(@"--------------");
}


// método base que pinta un rectangulo por defecto
-(void) pintate:(CGContextRef *) contexto
{
	NSLog(@"Ppintamos un rectangulo por defecto");
	
	CGContextSaveGState(contexto);								// guardardamos el contexto
	
	CGContextSetRGBFillColor(contexto, 255.0, 0.0,0.0,1.0);		// ponemos el color rojo por defecto
	CGRect rec = CGRectMake(x, y, ancho, alto);					// inicializamos el rectangulo
	CGContextFillRect(contexto,rec);							// pintamos el rectangulo
	
	CGContextRestoreGState(contexto);							// recuperamos el contexto
	
	// para saber si una clase conforma un protocolo conformsToProtocol:@protocol(clase)
}

@end
