//
//  CElipse.m
//  PintadorIPhone
//
//  Created by rcanales on 13/02/10.
//  Copyright 2010 Autentia. All rights reserved.
//

#import "CElipse.h"
#import "CoreGraphics/CoreGraphics.h"

@implementation CElipse

-(void) pintate:(CGContextRef *) contexto
{
	CGContextSaveGState(contexto);				// Guardamos los atributos del contexto 
	CGRect rec = CGRectMake(x, y, ancho, alto);	// creamos un rectangulo
	CGContextSetRGBFillColor(contexto, 0.0, 255.0 , 0.0 , 0.5);		// Cambiamos el color del contexto
	// la elipse es semitransparente
	
	NSLog(@"Pintamos un rectangulo por defecto");
	CGContextAddPath(contexto, [self creaCirculo]);		// añadimos el modificador de elipse
	CGContextClip(contexto);							// definimos el área de pitando.
	// si no restaurammos el contexto no podríamos pintar fuera
	
	CGContextFillRect(contexto,rec);					// pintamos un rectangulo con la máscara alterada
	
	CGContextRestoreGState(contexto);					// restauramos el estado del contexto de nuestra vista
	
	// para saber si una clase conforma un protocolo conformsToProtocol:@protocol(clase)
}


-(CGPathRef) creaCirculo
{
	CGMutablePathRef circulo = NULL;	// recordar incluir los ficheros de cabecera
	CGRect rec = CGRectMake(x, y, ancho, alto);
	
	circulo = CGPathCreateMutable();
	CGPathAddEllipseInRect(circulo, NULL, rec);
	
	return circulo;
}

@end